#if !defined(lint) && !defined(DOS)
static char rcsid[] = "$Id: rules.c,v 4.608 2000/11/17 01:51:37 chappa Exp $";
#endif
/*----------------------------------------------------------------------
  
            T H E    P I N E    M A I L   S Y S T E M

   Laurence Lundblade and Mike Seibel
   Networks and Distributed Computing
   Computing and Communications
   University of Washington
   Administration Builiding, AG-44
   Seattle, Washington, 98195, USA
   Internet: lgl@CAC.Washington.EDU
             mikes@CAC.Washington.EDU

   Please address all bugs and comments to "pine-bugs@cac.washington.edu"


   This set of rules was written by

   Eduardo Chappa (chappa@math.washington.edu)
   http://www.math.washington.edu/~chappa/pine/

   Original Version: November 1999
   Last Modified   : November 2000

   Send bug reports about this module to the address above.

   Pine and Pico are registered trademarks of the University of Washington.
   No commercial use of these trademarks may be made without prior written
   permission of the University of Washington.

   Pine, Pico, and Pilot software and its included text are Copyright
   1989-1999 by the University of Washington.

   The full text of our legal notices is contained in the file called
   CPYRIGHT, included with this distribution.


   Pine is in part based on The Elm Mail System:
    ***********************************************************************
    *  The Elm Mail System  -  Revision: 2.13                             *
    *                                                                     *
    * 			Copyright (c) 1986, 1987 Dave Taylor              *
    * 			Copyright (c) 1988, 1989 USENET Community Trust   *
    ***********************************************************************
 

  ----------------------------------------------------------------------*/

#include "rules.h"

char *process_rule (rule_data, rule_context, env) 
char *rule_data;
int  rule_context;
ENVELOPE *env;
{
    RULE_ACTION *action;       /* The part of the rule after the separator  */
    int   i;

    action = (RULE_ACTION *) fs_get(sizeof(RULE_ACTION));    
    action = get_action(rule_data,rule_context, env);
        
    if (action && action->value && *action->value){
        if (action->type)
          return (char *) detoken_src(action->value, rule_context, env, NULL, NULL);
        else{
	  for (i = 0; i < NFCN; i++){
	      if (action_has_function(action->value,rule_fcns[i].name))
		 return (*rule_fcns[i].execute)(action->value, rule_context, env);
	  }
	}
    }
    else
      return NULL;
}

/*
 * The following function tests if a condition given in a rule is satisfied or
 * not. Returns true if and only if the condition is satisfied.
 *
 *  Parameters: Rule_condition : the condition to be tested
 *	        rule_context   : in which context will the condition be tested
 *	        env	       : If we are in a context were we need an envelope
 *			 	 to test this variable is needed. It is NULL 
 *				 if not needed.
 */
int
test_condition(rule_condition, rule_context, env)
char *rule_condition;
int rule_context;
ENVELOPE *env;
{
    int   list_of_rel[NREL] = {0};
    int   save_to_rule, apply_rule, and_rel, test;
    char *separator;	     /* Pointer to the position of a separtor   */
    char *group;	     /* The value of the group to compare the token */
    int   next_step = TRUE;
    int   i;

    separator = (char *) malloc (200*sizeof(char));
    /*---------  find the relation -------------*/

      if (next_step){
	for (i = 0; i < NREL && next_step; i++){
 	   if (strstr(rule_condition,rel_rules_test[i].value)) {
		list_of_rel[i] = (strstr(rule_condition,rel_rules_test[i].value) != NULL);
		  next_step =  list_of_rel[i];
		}
	}
        next_step = next_step && (list_of_rel[NREL - 2] == list_of_rel[NREL - 1]);
      }

   /*------- Get the set (we call it group in here) ------------*/

    separator = strstr(rule_condition,OPEN_SET);
    if ((next_step) && (*separator++)){
        group = get_group(separator);
	group = (char *) detoken_src(group, rule_context, env, NULL, NULL);
    }
    else
	next_step = FALSE;


   /*------- Test the token with the set ------------*/

    if (next_step){
	i = -1;
	do{
	  if (list_of_rel[++i]){
	     list_of_rel[i] = (*rel_rules_test[i].execute)(group, rule_condition, env, rule_context);
             list_of_rel[i] = (list_of_rel[i] < NTOKENS);
	  }
	} while ((i < (NREL - 3)) && (!list_of_rel[i]));
        next_step = list_of_rel[i];
    }
   return next_step;
}

/* returns the name of the token it found */

char *
get_value_token (condition)
char *condition;
{
char *result;
char *q, *p;
int  length = 0,success = FALSE;
q = (char *) fs_get (strlen(condition)*sizeof(char));
*q = '\0';   
p = condition;
    while(*p){
	switch(*p){
	  case '_': success = !success;
		       *q++ = *p;
		       *p++;
			length++;
		    if (!success){
		        *q++ = '\0';
			length++;
			q -= length;
			return q;
		    }
		    break;
	  default : if (success) {	  
		       *q++ = *p;
		       *p++;
			length++;
		    }
		    else
			*p++;
		   break;
		}
	}
}

int test_in (group, condition, env, rule_context)
char *group;
char *condition;
ENVELOPE *env;
int rule_context;
{
 int i = 0;
 char *test;
 char *src = get_value_token(condition);
 test = (char *) detoken_src(src, rule_context, env, NULL, NULL);
 if (test && *test)
 while ((i < NTOKENS) && ((strstr(condition,token_rules[i]) == NULL) 
	|| (strstr(group, test) == NULL)))
   i++;
  else
    i = NTOKENS;
return i;
}

int 
test_ni (group, condition, env, rule_context)
char *group;
char *condition;
ENVELOPE *env;
int rule_context;
{
 int i = 0;
 char *src = get_value_token(condition);
 while ((i < NTOKENS) && ((strstr(condition,token_rules[i]) == NULL) 
	|| !(contain(group,(char *) detoken_src(src, rule_context, env, NULL, NULL)))))
   i++;
return i;
}

int test_not_in (group, condition, env, rule_context)
char *group;
char *condition;
ENVELOPE *env;
int rule_context;
{
 int i = 0;
 char *test;
 char *src = get_value_token(condition);
 test = (char *) detoken_src(src, rule_context, env, NULL, NULL);
 if (test && *test)
 while ((i < NTOKENS) && ((strstr(condition,token_rules[i]) == NULL) 
	|| ((int) strstr(group, test) != 0)))
   i++;
  else
    i = NTOKENS;
return i;
}

int test_not_ni (group, condition, env, rule_context)
char  *group;
char *condition;
ENVELOPE *env;
int rule_context;
{
 int i = 0;
 char *src = get_value_token(condition);
 while ((i < NTOKENS) && ((strstr(condition,token_rules[i]) == NULL) 
	|| (contain(group,(char *) detoken_src(src, rule_context, env, NULL, NULL)))))
   i++;
return i;
}

int test_eq (group, condition, env, rule_context)
char *group;
char *condition;
ENVELOPE *env;
int rule_context;
{
 int i = 0;
 char *src = get_value_token(condition);
 while ((i < NTOKENS) && ((strstr(condition,token_rules[i]) == NULL) 
	|| (mystrcmp(group, (char *) detoken_src(src, rule_context, env, NULL, NULL)))))
   i++;
return i;
}

int test_not_eq (group, condition, env, rule_context)
char *group;
char *condition;
ENVELOPE *env;
int rule_context;
{
 int i = 0;
 char *src = get_value_token(condition);
 while ((i < NTOKENS) && ((strstr(condition,token_rules[i]) == NULL) 
	|| (!mystrcmp(group, (char *) detoken_src(src, rule_context, env, NULL, NULL)))))
   i++;
return i;
}

int test_open (group, condition, env, rule_context)
char *group;
char *condition;
ENVELOPE *env;
int rule_context;
{
return 0;
}

int test_close (group, condition, env, rule_context)
char *group;
char *condition;
ENVELOPE *env;
int rule_context;
{
return 0;
}

int contain (group, condition)
char *group;
char *condition;
{
 int error = 0;
 if (!(condition && *condition))
    if (group && *group)
	return FALSE;
    else
	return TRUE;

 if (group && *group){
   int length = 0;
   char *group_backup;
   if (*group == ';')
      *group++;
   group_backup = (char *) fs_get (strlen(group)*sizeof(char));
   *group_backup = '\0';
   group_backup = advance_to_char(group,';', RELAXED, &error);
   if (group_backup && *group_backup){
      if (strstr(condition, group_backup))
	  return TRUE;
      else{
	   group += strlen(group_backup) + error;
	   if (*group){
              *group++;
              return contain(group,condition);
      	   }
	   else
	      return FALSE;
      }
   }
   else
      return TRUE; /* to make _TOKEN_ >> {} always TRUE */
 }
  else
  return TRUE; /* to make _TOKEN_ >> {} always TRUE */
}

int mystrcmp (group, condition) /* answers the question: are group and */
char *group;			/* condition different? */
char *condition;
{
 int error = 0;
 if (group && *group){
   int length = 0;
   char *group_backup;
    if (*group == ';')
	*group++;
    group_backup = (char *) fs_get(strlen(group)*sizeof(char));
    *group_backup = '\0';
    group_backup = advance_to_char(group,';', RELAXED, &error);
    if (!(condition && *condition))
	if (group_backup && *group_backup){
	   group += strlen(group_backup);
	   if (group && *group)
	      mystrcmp(group, condition);
	   else
	      return TRUE;
	}
	else
	   return FALSE;
    if (group_backup && *group_backup)
       if (!strcmp(group_backup, condition))
	   return FALSE;
       else{
	  group += strlen(group_backup);
	  if (*group)
	     return mystrcmp(group,condition);
	  else  /* (*group) */
	     if (condition && *condition)
		return TRUE;
	     else
		return FALSE;
    }
    else /* group_backup && *group_backup  */
	if (condition && *condition)
	   return TRUE;
	else
	   return FALSE;
 }
 else  /* group  && *group */
    if (condition && *condition)
       return TRUE;
    else
       return FALSE;
}

char *
do_trim (begin_text, end_text)
char *begin_text;
char *end_text;
{
   int error = 0;
   char *position;
   if (end_text && *end_text){
      char *end_text_backup;
      if (*end_text == ';')
	 *end_text++; 
      end_text_backup = (char *) malloc(strlen(end_text)*sizeof(char));
     *end_text_backup = '\0';
      end_text_backup = advance_to_char(end_text,';', RELAXED, &error);
      if (begin_text[strlen(begin_text) - 1] == '\002')
	begin_text[strlen(begin_text) - 1] = '\0';
      if (!(end_text_backup && *end_text_backup)){
	*end_text++;
	return do_trim (begin_text, end_text);
      }
      while (position = strstr(begin_text,end_text_backup)){
         char *new_begin_text;
	 new_begin_text = begin_text;
	 *position = '\0';
         position += strlen(end_text_backup);
         if (new_begin_text)
	    strcat(new_begin_text, position);
         else
	    new_begin_text = cpystr(position);
         begin_text = new_begin_text;
      }
	 end_text += strlen(end_text_backup);
	 if (end_text && *end_text){
	    end_text++;
            return do_trim (begin_text, end_text);
	 }
	 else
	     return begin_text;
   }
   else
     return begin_text;
}

char *save_to (condition, context, env)
char *condition;
int   context;
ENVELOPE *env;
{
int error = 0;
if (context & FOR_SAVE){
   condition = strstr(condition, SAVE_FCN);
   while (condition && *condition)
     if (*condition != '{')
	*condition++;
     else
	break;
   if (get_value_token(condition))
     condition = (char *) detoken_src(condition, context, env, NULL, NULL);
   *condition++;
   return advance_to_char(condition,'}', RELAXED, &error);
}
else
   return NULL;
}



char *
trim (condition, context, env)
char *condition;
int context;
ENVELOPE *env;
{
char *begin_text;
char *separator;
char *separator2;
char *end_text;

if (context & FOR_TRIM){

   /* we split the assigment and the value to be assigned */

   char *given_condition = cpystr(condition);
   int  length;

   if (given_condition && *given_condition)
	length = strlen(given_condition);
   else
	return NULL;
   given_condition +=length;
   for (length; length >0; length--){
        *given_condition--;
	if (separator = strstr(given_condition, "_TRIM_")){
	   separator += strlen(TRIM_FCN) + 1;
	   end_text = get_group(separator);
	   if (get_value_token(end_text))
     		end_text = (char *) detoken_src(end_text, context, env, NULL, NULL);
	   break;
	}
   }
   for (length; length >0; length--){
        *given_condition--;
	if (separator2 = strstr(given_condition, ":=")){
	break;
	}
   }
   length = 0;
   while (given_condition && *given_condition){
     *given_condition--;
      length++;
   }
   *given_condition++;
   begin_text = (char *) malloc ((length - 1)* sizeof(char));
   { int i;
     for (i = 0; i <= (length - 2); i++)
	begin_text[i] = given_condition[i];
   }
   begin_text[length - 1] = '\0';
   /* Now end_text contains the text to be looked to trim, begin_text contains
    * the text to be trimmed
    */
   if (get_value_token(begin_text))
   	begin_text = (char *) detoken_src(begin_text, context, env, NULL, NULL);
   return do_trim(begin_text,end_text);
}
else
   return NULL;
}


char *
replace (condition, context, env)
char *condition;
int context;
ENVELOPE *env;
{
char *begin_text;
char *separator;
char *separator2;
char *end_text;

if (context & FOR_REPLACE){

   /* we split the assigment and the value to be assigned */

   char *given_condition = cpystr(condition);
   int  length;

   if (given_condition && *given_condition)
	length = strlen(given_condition);
   else
	return NULL;
   given_condition +=length;
   for (length; length >0; length--){
        *given_condition--;
	if (separator = strstr(given_condition, REPLACE_FCN)){
	   separator += strlen(REPLACE_FCN) + 1;
	   end_text = get_group(separator);
	   break;
	}
   }
   if (get_value_token(end_text))
     end_text = (char *) detoken_src(end_text, context, env, NULL, NULL);
      return end_text;
}
else
   return NULL;
}


char *
get_sort_rule (condition, context,env)
char *condition;
int context;
ENVELOPE *env;
{
return execute_fcn(condition, SORT_FCN, context, FOR_SORT);
}

char *
get_index_rule (condition,context,env)
char *condition;
int context;
ENVELOPE *env;
{
return execute_fcn(condition, INDEX_FCN, context, FOR_INDEX);
}

char *
get_reply_str (condition,context,env)
char *condition;
int context;
ENVELOPE *env;
{
return execute_fcn((char *) detoken_src(condition, context, env, NULL, NULL), REPLY_FCN, context, FOR_REPLY_INTRO);
}

char *
get_reply_sub (condition,context,env)
char *condition;
int context;
ENVELOPE *env;
{
return execute_fcn(condition, RESUB_FCN, context, FOR_RESUB);
}

char *
startup_rule (condition,context,env)
char *condition;
int context;
ENVELOPE *env;
{
return execute_fcn(condition, STARTUP_FCN, context, FOR_STARTUP);
}


char *
execute_fcn (condition, given_condition,context, given_context)
char *condition;
char *given_condition;
int context;
int given_context;
{
int error = 0;
if (context & given_context){
   condition = strstr(condition, given_condition);
   while (condition && *condition)
     if (*condition != '{')
        *condition++;
     else
	break;
   *condition++;
   return advance_to_char(condition,'}', RELAXED, &error);
}
else
   return NULL;
}


/* advances until it finds 
 * given_char		  */

char *advance_to_char(given_string,given_char, flag, error) 
char *given_string;			     
char given_char;
int flag;
int *error;
{
   char *special_characters = "{};"; /* {};  are special characters*/
   char *string_backup;
   int  length = 0;
   int  length_string;
   int  is_special_character = FALSE;
   int  there_is_special_character = FALSE;

   if (error) 
	*error = 0;

   if (given_string && *given_string)
       length_string = strlen(given_string);
   else
       return NULL;

   while (special_characters && *special_characters && !is_special_character)
	is_special_character = (*special_characters++ == given_char);

   string_backup = (char *) fs_get(strlen(given_string)*sizeof(char));
   *string_backup = '\0';
   for (given_string;given_string && *given_string; given_string++){
	if (*given_string != given_char){
	   length++;
	   *string_backup++ = *given_string;
	}
	else{
	   char *new_string = given_string;
	   new_string--;
	   if (new_string && *new_string){
	       if (*new_string == '\\'){ /* special character was escaped */
		  *string_backup--;      /* correct string backup */
		  *string_backup++ = given_char;
		  there_is_special_character = TRUE;
		  *error++;
	       }
	       else
		  break;
	   }
	   else
	      break; /* found it in the first position! */
	}
   }

   if ((length == length_string) && (flag & STRICT))
     return NULL;   /* character not found */

   *string_backup++ = '\0';
   string_backup -= length + 1;
   given_string -= there_is_special_character ? length : length + *error;
   *error = there_is_special_character ? *error : 0;
   return string_backup;
}

RULE_ACTION *get_action(rule_data,rule_context, env)
char *rule_data;
int rule_context;
ENVELOPE *env;
{
    RULE_ACTION *result;
    char *new_rule, *p;
    char *condition[10];
    int number_conditions = 0;
    int begin_condition = FALSE, end_of_conditions = FALSE;
    int save_to_rule = FALSE, apply_rule = FALSE;
    int length = 0, test_ok = FALSE;
    int i = 0, try_again = FALSE;
    int error =0;

    /* We isolate any condition in a variable called "new_rule" and test it.
     * If all grammar is correct and all the conditions are satisfied the
     * rule is executed, otherwise return NULL
     */

    result = (RULE_ACTION *) fs_get(sizeof(RULE_ACTION));
    result->value = (char *) fs_get(200*sizeof(char));
    new_rule = (char *) fs_get(200*sizeof(char));
    *new_rule = '\0';
    p = rule_data;
    while ((*p) && (!try_again)){
	switch(*p){
	  case '_' : begin_condition = !begin_condition;
		     if (begin_condition){
			new_rule = advance_to_char(p,'}', STRICT, &error);
			if (new_rule && *new_rule){
			   begin_condition = !begin_condition;
			   length = strlen(new_rule);
			   new_rule += length;
			   *new_rule++ = '}';
			   *new_rule   = '\0';
			   new_rule -= length + 1;
			   p += length + 1;
			   test_ok = TRUE;
			   number_conditions++;
			}
			else
			   return (RULE_ACTION *) NULL;  /* Bad Grammar, condition not ended */
			if (!good_grammar(new_rule))
			   return (RULE_ACTION *) NULL;  /* Bad Grammar in condition */
		     }
		     else
			return NULL; /* Bad Grammar, forbidden '_' before condition */ 
		     break;
	  case '&' : if ((!begin_condition) && (p[1] != '&'))
			return (RULE_ACTION *) NULL; /* Bad Grammar, user needed to write && */
		     else
			*p++;
		     break;	     /*	outside a condition, but he/she did not */
	  case '=' : if ((!begin_condition) && (p[1] != '>'))
			return (RULE_ACTION *) NULL; /* Bad Grammar, user did not write => */
		     else 	     /*	outside a condition */
			if (!begin_condition){
			   apply_rule = rule_context & FOR_RESUB|FOR_FOLDER|FOR_INDEX|FOR_SAVE|FOR_STARTUP|FOR_REPLY_INTRO|FOR_REPLACE|FOR_TRIM;
			   end_of_conditions = TRUE;
			   *p++;
			}
		     break;
	  case '-' : if ((!begin_condition) && (p[1] != '>'))
			return (RULE_ACTION *) NULL; /* Bad Grammar, user did not write -> */
		     else 	     /*	outside a condition */
			if (!begin_condition){
			   save_to_rule = rule_context & FOR_SAVE;
			   end_of_conditions = TRUE;
			   *p++;
			}
		     break;
	  default  : break;

	}
	*p++;
	if (end_of_conditions){
 	   if (save_to_rule || apply_rule){
	      result->type  = save_to_rule;
	      if (p && (p[0] == ' '))
	         while (*p == ' ')
		 *p++;	
	      result->value = p;
	      if (result && result->value && *result->value){
		  if (result->type)
		     try_again = TRUE;
		  else{
		     for (i = 0; i < NFCN; i++)
			if ((action_has_function(result->value,rule_fcns[i].name)) &&
			     (rule_context & rule_fcns[i].what_for))
		           try_again = TRUE;
		     if (!try_again)
		         return (RULE_ACTION *) NULL; /* wrong context*/
		  }
	      }
	   }
	   else
	      return (RULE_ACTION *) NULL; /* wrong context*/
	}
	if (test_ok){
           condition[i] = (char *) fs_get(200*sizeof(char));
	   condition[i++] = cpystr(new_rule);
	}
	test_ok = FALSE;
      }
    i = 0;
    while ((i < number_conditions) && (try_again)){
	try_again = try_again && test_condition(condition[i++],rule_context,env);
    }
    if (try_again)
	return result;
    else
	return (RULE_ACTION *) NULL;
   }

char *get_group(given_string)
char *given_string;
{
int error = 0;
return advance_to_char(given_string,'}', RELAXED, &error);
}

int good_grammar(condition)
char *condition;
{
   int error =0;
   int end_test = FALSE;
   int i = 0;
   char *token;
   token = (char *) fs_get(strlen(condition)*sizeof(char));
   *token = '\0';
   while (!(token && *token) && !end_test && (i < NTOKENS))
	end_test = ((token = strstr(condition,token_rules[i++])) == condition);
   if (end_test){
      condition += strlen(token_rules[--i]);
      if (condition && *condition){
	while (*condition == ' ')
	   *condition++;
	if (condition && *condition){
	   char *separator;
   	   separator = (char *) fs_get(strlen(condition)*sizeof(char));
	   *separator = '\0';
	   i = 0;
	   end_test = FALSE; /* rewrite end_test from the beginning */
	   while (!(separator && *separator) && !end_test && (i < (NREL - 2)))
	     end_test = ((separator = strstr(condition,rel_rules_test[i++].value)) == condition);
	   if (end_test){
	      condition += strlen(rel_rules_test[--i].value);
	      if (condition && *condition){
		while (*condition == ' ')
		   *condition++;
		if (condition && *condition){
		   char *open_set;
		   open_set = (char *) fs_get(strlen(condition)*sizeof(char));
		   *open_set = '\0';
		   open_set = (*condition == '{') ? condition : NULL;
		   end_test = open_set && *open_set;
		   end_test = end_test ? 
				(int) advance_to_char(open_set,'}', STRICT, &error) :
				FALSE;
		}
		else
		   end_test = FALSE; /* wrote token, separator, space */
				     /*	and nothing more */
	      }
	      else
		end_test = FALSE; /* wrote token, separator and nothing more */
	   }
	}
	else
	  end_test = FALSE; /* wrote token, blank space and nothing more */
      }
      else
	end_test = FALSE; /* wrote token but nothing more */
   }
   return end_test;
}


int action_has_function(action,function)
char *action;
char *function;
{
  char *where = strstr(action,function);
  char *token;
  int i = 0;

  if (!where)
      return FALSE;

  if (where == action)
      return TRUE;

  /* The action must have the form _TOKEN_ := function{something} */

  token = get_value_token(action);
  if (token){
     char *where_token = strstr(action, token);

     while ((i < NTOKENS) && (strcmp(token,token_rules[i])))
        i++;
     if (i == NTOKENS)
         return FALSE;

     if (where_token != action)
	return FALSE; /* the action looks like "garbage _TOKEN_" */

     action += strlen(token) + 1;
     while (*action == ' ')
	*action++;

     if ((*action == ':') && (*++action == '=')){
	*action++;
	while (*action == ' ')
	   *action++;
	where_token = strstr(action,function);
	if (where_token == action)
	   return TRUE; 	
     }
  }
  return FALSE;
}
